package com.dsic.gj_erp.pc.dto;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.dto.data.Bom;
import com.dsic.gj_erp.pc.dto.data.钢料需求;
import com.dsic.gj_erp.pc.service.套料图工序接口;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;
import java.util.Optional;
import java.util.concurrent.atomic.AtomicBoolean;

import static com.dsic.gj_erp.pc.Constant.工序CD;
import static com.dsic.gj_erp.pc.DataFactory.提取资源;
import static com.dsic.gj_erp.pc.DataFactory.搜索可用资源;
import static com.dsic.gj_erp.pc.Manager.from;
import static com.dsic.gj_erp.pc.Manager.套料图所占工序的资源;

@Getter
@Setter
public abstract class 套料图工序 implements 套料图工序接口 {
    protected String kw;
    protected String zl;
    protected 钢料需求 _钢料需求;
    protected Bom bom;
    protected String 需求日期;
    protected Date _需求日期;
    protected List<Constant.工序> 工序;

    @Override
    public void run() {
        if (ObjUtil.isEmpty(this.bom)||StrUtil.isEmpty(this.bom.getTzbh())){
            return;
        }
        this._需求日期 = DateUtil.parse(this.需求日期, "yyyy/MM/dd");
        double 需求数量 = 1;
        this.工序.forEach(_工序 -> {
            if (!this.已占资源(_工序)&&!this.占用资源(_工序,需求数量)){
                if (bom.get所在资源() == null) {
                    Optional<资源> 可用资源 = 搜索可用资源(_工序, DateUtil.parse(from, "yyyy/MM/dd"), this._需求日期, 需求数量);
                    可用资源.ifPresent(_资源 -> {
                        _资源.占用资源(_工序,this.bom,需求数量);
                    });
                }

                //没有可用资源放入月末(强占),待手工调整
                if (bom.get所在资源() == null) {
                    资源 _资源 = 提取资源(DateUtil.endOfMonth(DateUtil.parse(this.需求日期, "yyyy/MM/dd")));
                    _资源.强占资源(_工序,this.bom,需求数量);
                }
            }
        });
    }

    protected boolean 占用资源(Constant.工序 _工序,double 需求数量){
        Integer cd = 工序CD.get(_工序);
        DateTime dateTime = DateUtil.offsetDay(this._需求日期, cd);
        资源 _资源 = 提取资源(dateTime);
        AtomicBoolean 占用成功=new AtomicBoolean(false);
        try {
            _资源.占用资源(_工序,this.bom,需求数量);
            this.bom.set所在资源(_资源);
            占用成功.set(true);
        }catch (Exception e){

        }

        return 占用成功.get();
    }

    protected boolean 已占资源(Constant.工序 _工序){
        资源 已占资源 = this.获取所在资源();
        工序产能 工序产能 = null;
        if (已占资源 != null) {
            工序产能 = 已占资源.get工序产能MAP().get(_工序);
        }
        if (工序产能 != null && 工序产能.get资源占用图纸表().contains(bom.getTzbh())) {
            bom.set所在资源(已占资源);
            Optional<设备> _设备 = 工序产能.获取已占用设备(bom.getTzbh());
            _设备.ifPresent(bom::set所在设备);
            return true;
        }
        return false;
    }

    protected 资源 获取所在资源() {
        return 套料图所占工序的资源.get(this.bom.getTzbh());
    }

    @Override
    public 套料图工序 钢料需求(钢料需求 _钢料需求) {
        this._钢料需求=_钢料需求;
        return this;
    }
}
